<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Views/InheritanceGraph.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Views/InheritanceGraph.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Views/InheritanceGraph.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> *</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> IR, ASG</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.View <span class="py-keyword">import</span> View</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line13"></a><span class="lineno"> 13</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">import</span> os</span>
<a id="line15"></a><span class="lineno"> 15</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/DeclarationFinder.html">DeclarationFinder</a>(ASG.Visitor):</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/DeclarationFinder.html#__init__">__init__</a>(self, types, verbose):</span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">      self.types = types</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">      self.verbose = verbose</span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/DeclarationFinder.html#__call__">__call__</a>(self, name):</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">      <span class="py-keyword">try</span>:</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">         typeobj = self.types[name]</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">      <span class="py-keyword">except</span> KeyError:</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">         <span class="py-comment"># Eg: Unknown parent which has been NameMapped</span></span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">         <span class="py-keyword">if</span> self.verbose: <span class="py-keyword">print</span> <span class="py-string">&quot;Warning: %s not found in type dict.&quot;</span>%(name,)</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">         <span class="py-keyword">return</span> None</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">      self.__decl = None</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">      typeobj.accept(self)</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">      <span class="py-comment">#if self.__decl is None:</span></span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">      <span class="py-comment">#    return None</span></span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">      <span class="py-keyword">return</span> self.__decl</span>
<a id="line34"></a><span class="lineno"> 34</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/DeclarationFinder.html#visit_buitin_type_id">visit_buitin_type_id</a>(self, type): <span class="py-keyword">return</span></span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/DeclarationFinder.html#visit_unknown_type_id">visit_unknown_type_id</a>(self, type): <span class="py-keyword">return</span></span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/DeclarationFinder.html#visit_declared_type_id">visit_declared_type_id</a>(self, type): self.__decl = type.declaration</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/DeclarationFinder.html#visit_modifier_type_id">visit_modifier_type_id</a>(self, type): type.alias.accept(self)</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/DeclarationFinder.html#visit_array_type_id">visit_array_type_id</a>(self, type): type.alias.accept(self)</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/DeclarationFinder.html#visit_template_id">visit_template_id</a>(self, type): self.__decl = type.declaration</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/DeclarationFinder.html#visit_parametrized_type_id">visit_parametrized_type_id</a>(self, type): type.template.accept(self)</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/DeclarationFinder.html#visit_function_type_id">visit_function_type_id</a>(self, type): <span class="py-keyword">return</span></span>
<a id="line43"></a><span class="lineno"> 43</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph.html#find_common_name">find_common_name</a>(graph):</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">   common_name = list(graph[0])</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">   <span class="py-keyword">for</span> decl_name <span class="py-keyword">in</span> graph[1:]:</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">      <span class="py-keyword">if</span> len(common_name) &gt; len(decl_name):</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">         common_name = common_name[:len(decl_name)]</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">      <span class="py-keyword">for</span> i <span class="py-keyword">in</span> range(min(len(decl_name), len(common_name))):</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">         <span class="py-keyword">if</span> decl_name[i] != common_name[i]:</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">            common_name = common_name[:i]</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">            <span class="py-keyword">break</span></span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">   <span class="py-keyword">return</span> <span class="py-string">'::'</span>.join(common_name)</span>
<a id="line54"></a><span class="lineno"> 54</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/InheritanceGraph.html">InheritanceGraph</a>(View):</span>
<a id="line56"></a><span class="lineno"> 56</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">   min_size = Parameter(2, <span class="py-string">'minimum number of nodes for a graph to be displayed'</span>)</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">   min_group_size = Parameter(5, <span class="py-string">'how many nodes to put into a group'</span>)</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">   direction = Parameter(<span class="py-string">'vertical'</span>, <span class="py-string">'layout of the graph'</span>)</span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/InheritanceGraph.html#register">register</a>(self, frame):</span>
<a id="line62"></a><span class="lineno"> 62</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">      super(InheritanceGraph, self).register(frame)</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">      self.decl_finder = DeclarationFinder(self.processor.ir.asg.types,</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">                                           self.processor.verbose)</span>
<a id="line66"></a><span class="lineno"> 66</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/InheritanceGraph.html#filename">filename</a>(self):</span>
<a id="line68"></a><span class="lineno"> 68</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">      <span class="py-keyword">if</span> self.main:</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">         <span class="py-keyword">return</span> self.directory_layout.index()</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">         <span class="py-keyword">return</span> self.directory_layout.special(<span class="py-string">'InheritanceGraph'</span>)</span>
<a id="line73"></a><span class="lineno"> 73</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/InheritanceGraph.html#title">title</a>(self):</span>
<a id="line75"></a><span class="lineno"> 75</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">      <span class="py-keyword">return</span> <span class="py-string">'Inheritance Graph'</span></span>
<a id="line77"></a><span class="lineno"> 77</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/InheritanceGraph.html#root">root</a>(self):</span>
<a id="line79"></a><span class="lineno"> 79</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">      <span class="py-keyword">return</span> self.filename(), self.title()</span>
<a id="line81"></a><span class="lineno"> 81</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/InheritanceGraph.html#consolidate">consolidate</a>(self, graphs):</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Consolidates small graphs into larger ones&quot;&quot;&quot;</span></span>
<a id="line84"></a><span class="lineno"> 84</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">      <span class="py-comment"># Weed out the small graphs and group by common base name</span></span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">      common = {}</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">      <span class="py-keyword">for</span> graph <span class="py-keyword">in</span> graphs:</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">         len_graph = len(graph)</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">         <span class="py-keyword">if</span> len_graph &lt; self.min_size:</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">            <span class="py-comment"># Ignore the graph</span></span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">            <span class="py-keyword">continue</span></span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">         common.setdefault(find_common_name(graph), []).append(graph)</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">      <span class="py-comment"># Consolidate each group</span></span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">      <span class="py-keyword">for</span> name, graphs <span class="py-keyword">in</span> common.items():</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">         conned = []</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">         pending = []</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">         <span class="py-keyword">for</span> graph <span class="py-keyword">in</span> graphs:</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">            <span class="py-comment"># Try adding to an already pending graph</span></span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">            <span class="py-keyword">for</span> pend <span class="py-keyword">in</span> pending:</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">               <span class="py-keyword">if</span> len_graph + len(pend) &lt;= self.min_group_size:</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">                  pend.extend(graph)</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">                  graph = None</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">                  <span class="py-keyword">if</span> len(pend) == self.min_group_size:</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">                     conned.append(pend)</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">                     pending.remove(pend)</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">                  <span class="py-keyword">break</span></span>
<a id="line107"></a><span class="lineno">107</span><span class="line">            <span class="py-keyword">if</span> graph:</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">               <span class="py-keyword">if</span> len_graph &gt;= self.min_group_size:</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">                  <span class="py-comment"># Add to final list</span></span>
<a id="line110"></a><span class="lineno">110</span><span class="line">                  conned.append(graph)</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">               <span class="py-keyword">else</span>:</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">                  <span class="py-comment"># Add to pending list</span></span>
<a id="line113"></a><span class="lineno">113</span><span class="line">                  pending.append(graph)</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">         graphs[:] = conned + pending</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">      <span class="py-keyword">return</span> common</span>
<a id="line116"></a><span class="lineno">116</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/InheritanceGraph/InheritanceGraph.html#process">process</a>(self):</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Creates a file with the inheritance graph&quot;&quot;&quot;</span></span>
<a id="line119"></a><span class="lineno">119</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">      filename = self.filename()</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">      self.start_file()</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">      self.write_navigation_bar()</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">      self.write(element(<span class="py-string">'h1'</span>, <span class="py-string">&quot;Inheritance Graph&quot;</span>))</span>
<a id="line124"></a><span class="lineno">124</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">      <span class="py-keyword">from</span> Synopsis.Formatters <span class="py-keyword">import</span> Dot</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">      <span class="py-comment"># Create a toc file for Dot to use</span></span>
<a id="line127"></a><span class="lineno">127</span><span class="line">      toc_file = filename + <span class="py-string">&quot;-dot.toc&quot;</span></span>
<a id="line128"></a><span class="lineno">128</span><span class="line">      self.processor.toc.store(toc_file)</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">      graphs = self.processor.class_tree.graphs()</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">      count = 0</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">      <span class="py-comment"># Consolidate the graphs, and sort to make the largest appear first</span></span>
<a id="line132"></a><span class="lineno">132</span><span class="line">      lensorter = <span class="py-keyword">lambda</span> a, b: cmp(len(b),len(a))</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">      common_graphs = self.consolidate(graphs)</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">      names = common_graphs.keys()</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">      names.sort()</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">      <span class="py-keyword">for</span> name <span class="py-keyword">in</span> names:</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">         graphs = common_graphs[name]</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">         graphs.sort(lensorter)</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">         <span class="py-keyword">if</span> name:</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">            self.write(<span class="py-string">'&lt;div class=&quot;inheritance-group&quot;&gt;'</span>)</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">            type_str = <span class="py-string">''</span></span>
<a id="line142"></a><span class="lineno">142</span><span class="line">            types = self.processor.ir.asg.types</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">            type = types.get(name, None)</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">            <span class="py-keyword">if</span> isinstance(type, ASG.DeclaredTypeId):</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">               type_str = type.declaration.type + <span class="py-string">' '</span></span>
<a id="line146"></a><span class="lineno">146</span><span class="line">            self.write(<span class="py-string">'Graphs in '</span>+type_str+name+<span class="py-string">':&lt;br/&gt;'</span>)</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">         <span class="py-keyword">for</span> graph <span class="py-keyword">in</span> graphs:</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">            <span class="py-keyword">if</span> self.processor.verbose: <span class="py-keyword">print</span> <span class="py-string">&quot;Creating graph #%s - %s classes&quot;</span>%(count,len(graph))</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">            <span class="py-comment"># Find declarations</span></span>
<a id="line150"></a><span class="lineno">150</span><span class="line">            declarations = map(self.decl_finder, graph)</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">            declarations = filter(<span class="py-keyword">lambda</span> x: x <span class="py-keyword">is</span> <span class="py-keyword">not</span> None, declarations)</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">            <span class="py-comment">#output = os.path.join(self.processor.output, 'InheritanceGraph', str(count))</span></span>
<a id="line153"></a><span class="lineno">153</span><span class="line">            output = os.path.join(self.processor.output,</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">                                  os.path.splitext(self.filename())[0]) + <span class="py-string">'-%s'</span>%count</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">            dot = Dot.Formatter(bgcolor=self.processor.graph_color)</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">            ir = IR.IR(files={}, asg=ASG.ASG(declarations, self.processor.ir.asg.types))</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">            <span class="py-keyword">try</span>:</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">               dot.process(ir,</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">                           output=output,</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">                           format=<span class="py-string">'html'</span>,</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">                           toc_in=[toc_file],</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">                           base_url=self.filename(),</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">                           title=<span class="py-string">'Synopsis %s'</span>%count,</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">                           layout=self.direction)</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">               dot_file = open(output + <span class="py-string">'.html'</span>, <span class="py-string">'r'</span>)</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">               self.write(dot_file.read())</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">               dot_file.close()</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">               os.remove(output + <span class="py-string">&quot;.html&quot;</span>)</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">            <span class="py-keyword">except</span> InvalidCommand, e:</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">               <span class="py-keyword">print</span> <span class="py-string">'Warning : %s'</span>%str(e)</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">            count = count + 1</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">         <span class="py-keyword">if</span> name:</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">            self.write(<span class="py-string">'&lt;/div&gt;'</span>)</span>
<a id="line174"></a><span class="lineno">174</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">      os.remove(toc_file)</span>
<a id="line176"></a><span class="lineno">176</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">      self.end_file()</span>
<a id="line178"></a><span class="lineno">178</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:14 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
